local grid={}
 grid.effect = love.graphics.newPixelEffect[[

extern vec2 screen;
extern vec2 mouse;
extern number time;
extern number lines;		// number of rotating lines
extern number sweep_speed;

#define PI 3.1416
#define BORDER_WIDTH 0.03
#define SIZE 0.5
number GRID_SIZE = SIZE * 48.0;	// grid size (not all sizes work)

vec3 color(number d) { return d * vec3( 0.0, 1.0, 0.5 ); }	// fill color

int mod(int a, int b) { return a - ((a / b) * b); }			// GLSL non-sense math

vec4 effect( vec4 color, Image tex, vec2 tc, vec2 pc )
	{
	vec2 p		=  ( -1.0 + 2.0 * ( pc.xy / screen.xy ) );
	p.x			+= sin( time + ( p.y * 2.5 ) ) * 0.1;
	p.y			*= (p.y * p.y);
	p 			-= ( 2.0 * mouse.xy / screen.xy ) - vec2( 1.0 );
	p.x 		*= ( screen.x / screen.y );

	number a 	= ( atan( p.y, p.x ) + sweep_speed*time );
	number r 	= sqrt( dot( p, p ) );

	vec2 		uv;					// fill
	uv.x 		= 0.1 / r;
	uv.y 		= lines * a / PI;		// number of sweep lines
	vec3 col 	= color( pow( fract( uv.y / -2.0 ), 15.0 ) );

	number len 	= 2.0 * dot( p, p );
	if (len > SIZE) col = vec3( 0.5, 0.05, 0.05);	// outline color
	if (len > SIZE+BORDER_WIDTH) col = vec3( 0.0, 0.00, 0.10);	// limit border width

	bool grid_x = mod( int( pc.x ) - int( screen.x / 2.0 ), GRID_SIZE ) == 0;
	bool grid_y = mod( int( pc.y ) - int( screen.y / 2.0 ), GRID_SIZE ) == 0;

	if ( len < SIZE )		// length of grid lines
		{
		if ( grid_x || grid_y ) col += color( 0.5 );
		if ( grid_x && grid_y ) col += color( 1.0 );
		}
	return vec4( col, 1.0 );
	}
]]

return grid
